#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

int main(argc,argv)
     int argc;
     char **argv;
{
  char *query;
  int i;

  query=getenv("QUERY_STRING");
  printf("Content-Type: text/html\n\n");
  if(argc > 1) {
    i = 1;
    do {
      if (!query) {
	query=malloc(strlen(argv[i]+2));
	if (!query) return;
	*query = 0;
      } else {
	query=realloc(query,strlen(query)+strlen(argv[i])+2);
	if (!query) return;
      }
      strcat(query,argv[i]);
      strcat(query," ");
      i++;
    } while (i < argc);
    query[strlen(query)-1] = 0;	/* chop trailing space... */
  }
  putchar('\n');
  do_callsign(query);
}

int write_str(fd,s)
     int fd;
     char *s;
{
  return write(fd,s,strlen(s));
}

int do_callsign(request)
     char *request;
{
  char *r;
  int p, st, n;

  char buf[1025];

  if(!request) {
    printf("<isindex><h1>Enter the amateur radio callsign you wish to look up</h1>");
    printf("e.g. \"N1DPU\" <p>");
    printf("This server contains mostly information on locations within the US\n");
    printf("and is provided by the University of Buffalo.<p>");
    printf("Gateway written by <A HREF=\"/people/eichin/mwe.html\">Mark Eichin</A>\n");
    return;
  }
  for(r=request;*r;r++) if (*r == '+') *r = ' ';
  printf("<isindex>");

/* ***** */
  {
    int t;
    sigset_t m;
    t = sigprocmask(0,0,&m);
    if(t) { perror("sigprocmask"); exit(1); }
    printf("mask: %x\n",m);
  }
  {
    int i;
    struct sigvec sv;
    for (i=0; i< NSIG; i++) {
      sigvec(i,0,&sv);
      if(i && !(i & 7)) printf("\n");
      printf("%d: ",i);
      if (sv.sv_handler == SIG_IGN)
	printf("SIG_IGN");
      else if (sv.sv_handler == SIG_DFL)
	printf("SIG_DFL");
      else 
	printf("0x%x");
      if ((i & 7) != 7) printf("\t");
    }
  }

/* ***** */

  p = open_port("callsign.cs.buffalo.edu",2000);
  
  printf("<h1>Amateur License Callbook Query:  \"%s\"</h1><pre>\n",request);
  do {
    n = read(p,buf,1024);
    buf[n] = 0;
    if(!strcmp(buf,"\377\373\001\377\373\003")) {
      write_str(p, "\377\375\001\377\375\003");
    }
    printf("line={%s}\n",buf);
    r = buf+strlen(buf)-3;
  } while(strcmp(">> ",r));
  write_str(p, "call ");
  write_str(p, request);
  write_str(p, "\n\r");
  do {
    n = read(p,buf,1024);
    buf[n] = 0;
    printf("line2={%s}\n\r",buf);
    r = buf+strlen(buf)-3;
  } while(strcmp(">> ",r));
  write_str(p,"quit\n\r");
  printf("</pre>");
}

int open_port(server,portnum)
     char *server;
     int portnum;
{
  struct hostent *hp;
  struct sockaddr_in sin;
  int s;

  hp = gethostbyname (server);
  if (hp == NULL) {
    perror("callsign: gethostbyname");
    exit(1);
  }
  s = socket (AF_INET, SOCK_STREAM, 0);
  if (s < 0) {
    perror("callsign: socket");
    exit(1);
  }

  sin.sin_family = AF_INET;
  sin.sin_addr.s_addr = INADDR_ANY;
  sin.sin_port = 0;
  
  if (bind (s, (struct sockaddr *) &sin, sizeof sin) < 0) {
    perror("callsign: bind");
    exit(1);
  }
  memcpy (&sin.sin_addr, hp->h_addr, hp->h_length);
  sin.sin_port = htons(portnum);

  if (connect (s, (struct sockaddr *) &sin, sizeof sin) < 0) {
    perror("callsign: connect");
    close(s);
    exit(1);
  }

  return s;
}
