#!/usr/athena/bin/perl

require 'parseform.pl';

$regfile = '/tmp/regfile';
$logfile = '/usr/local/www/logs/reg_activity.log';

&reg_activity();

sub reg_activity {
    local($query);

    $query = $ENV{'QUERY_STRING'};
    %form = &parseform($query);

    while (-e $regfile) { sleep 3; }

    print "Content-Type: text/html\n\n";
    print "<head>\n";
    print "<link rev=made href=\"tritan\@mit.edu\">\n";
    print "<link rev=owns href=\"webmaster\@mit.edu\">\n";
    print "<title>register output</title>\n";
    print "</head>\n";
    print "<body>\n";

    if (!open(REGFILE, ">$regfile")) {
      print "<p>Internal Error (1) processing request. Sorry.</p>\n";
      print "<p>Try again later or send mail to ",
            "<a href=\"mailto:webmaster@mit.edu\">webmaster@mit.edu</a>.",
            "</p>\n";
    } else {
      print "<h1>Activity Registered</h1>\n";

      print "Your activity is now registered with the SIPB ";
      print "webmasters. Below is the information that you provided.";
      print "<p>\n";

      print "Please verify the correctness of the information below. ";
      print "If there are any errors, please re-submit your request.";
      print "<p>\n";

      print "Once your activity has been placed on the SIPB activities ";
      print "page, your contact person should receive email confimation.";
      print "<p>\n";

      print "If you have any questions, please send email to ";
      print "<a href=\"mailto:webmaster@mit.edu\">webmaster@mit.edu</a>.";
      print "<p>\n";

      print "<hr>\n";

      print "<strong>Activity name =</strong> \"$form{'name'}\"<br>\n";
      print "<strong>Category      =</strong> \"$form{'category'}\"<br>\n";
      print "<strong>Contact       =</strong> \"$form{'contact'}\"<br>\n";
      print "<strong>Home page     =</strong> \"$form{'location'}\" ";
      print "($form{'type'})<br>\n";
      print "<strong>Icon          =</strong> \"$form{'icon'}\" ";
      print "($form{'icon_type'})<br>\n";
      print "<strong>Blurb:</strong><br>\n";
      print "<blockquote>\n";
      print $form{'blurb'};
      print "</blockquote>\n";
    }

    print "<hr>\n";

    print "<address>\n";
    print "<a href=\"/webmasters.html\">webmaster@mit.edu</a>\n";
    print "</address>\n";
    print "</body>\n";

    print REGFILE "*** Activity Registration Request ***\n\n";
    print REGFILE "Activity name = $form{'name'}\n";
    print REGFILE "Category      = $form{'category'}\n";
    print REGFILE "Contact       = $form{'contact'}\n";
    print REGFILE "Location      = $form{'location'} ($form{'type'})\n";
    print REGFILE "Icon          = $form{'location'} ($form{'icon_type'})\n";
    print REGFILE "Blurb:\n";
    print REGFILE "$form{'blurb'}\n\n";

    close(REGFILE);

    system("/bin/mail webmaster\@mit.edu < $regfile");
    if (-e $logfile) {
      system("/bin/cat $regfile >> $logfile");
    } else {
      system("/bin/cat $regfile > $logfile");
    }
    unlink($regfile);
}

1;
